<?php 
/**
 * Convertidor de divisas - repaso_4.php
 * 
 * @author    Bartolomé Sintes Marco <bartolome.sintes+mclibre@gmail.com>
 * @copyright 2009 Bartolomé Sintes Marco
 * @license   http://www.gnu.org/licenses/agpl.txt AGPL 3 or later
 * @version   2009-04-27
 * @link      http://www.mclibre.org
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

print "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?".">\n"; 
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
       "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <title>Convertidor de divisas (Resultado).
  Repaso 1. Ejercicios. PHP. Bartolomé Sintes Marco</title>
  <link href="mclibre_php_soluciones.css" rel="stylesheet" type="text/css" 
  title="Color" />
</head>

<body>
<h1>Convertidor de divisas (Resultado)</h1>
<?php
function recoge($var)
{ 
    $tmp = (isset($_REQUEST[$var])) ? trim(strip_tags($_REQUEST[$var])) : '';
    if (get_magic_quotes_gpc()) {
       $tmp = stripslashes($tmp);
    }
    $tmp = str_replace('&', '&amp;',  $tmp);
    $tmp = str_replace('"', '&quot;', $tmp);
    return $tmp;
}

define('NUM_MAXIMO', 1000000);

$cantidad   = recoge('cantidad');
$origen     = recoge('origen');
$destino    = recoge('destino');
$cantidadOk = FALSE;

$monedas      = array('EUR', 'USD', 'GBP', 'JPY', 'ESP');
$factor       = array('EUR'=> 1, 'USD'=>1.31481, 'GBP'=>0.89807, 'JPY'=>132.113, 'ESP'=>166.386);
$nombreMoneda = array('EUR'=> 'euros', 'USD'=>'dólares USA', 
    'GBP'=>'libras esterlinas', 'JPY'=>'yenes japoneses', 'ESP'=>'pesetas españolas');

if ($cantidad=="") {
    print "<p style=\"color: red\">No ha escrito la cantidad de dinero.</p>\n";
} elseif (!is_numeric($cantidad)) { 
    print "<p style=\"color: red\">No ha escrito la cantidad de dinero como número.</p>\n";
} elseif (!ctype_digit($cantidad)) { 
    print "<p style=\"color: red\">La cantidad de dinero no es un número entero positivo (sin parte decimal)</p>\n";
} elseif ($cantidad>=NUM_MAXIMO) {
    print "<p style=\"color: red\">La cantidad de dinero no es inferior a ".NUM_MAXIMO.".</p>\n";
} else {
    $cantidadOk = TRUE;
}

if (!in_array($origen, $monedas)) {
    print "  <p style=\"color:red\">No ha escrito correctamente la moneda de origen.</p>\n";
} else {
    $origenOk = TRUE;
}

if (!in_array($destino, $monedas)) {
    print "  <p style=\"color:red\">No ha escrito correctamente la moneda de destino.</p>\n";
} else {
    $destinoOk = TRUE;
}

if ($cantidadOk && $origenOk && $destinoOk) {
    $result = round($cantidad/$factor[$origen]*$factor[$destino], 2);
    print "<p>$cantidad $nombreMoneda[$origen] son $result $nombreMoneda[$destino].</p>\n";
    print "<p>Gracias por utilizar este convertidor.</p>\n";
}

print "<p><a href=\"repaso_4.html\">Volver al formulario.</a></p>\n";
?>

<address>
  Esta página forma parte del curso "Páginas web con PHP" disponible en <a
  href="http://www.mclibre.org/">http://www.mclibre.org</a><br />
  Autor: Bartolomé Sintes Marco<br />
  Última modificación de esta página: 27 de abril de 2009
</address>
<p class="licencia">El programa PHP que genera esta página está bajo 
<a rel="license" href="http://www.gnu.org/licenses/agpl.txt">licencia AGPL 3 o
posterior</a>.</p>
</body>
</html>
